<template>
  <div class="dropzone">
    <!-- UPLOAD -->
    <div
      v-if="uploadSupported"
      class="dropzone dropzoneBorder"
      @drop="handleDropEvent"
      @dragover="handleOnDragOver"
      @dragleave="handleOnDragLeave"
      @dragenter.prevent
      @dragover.prevent
    >
      <div
        class="justify-center items-center"
        style="margin: 25px"
      >
        <div
          class="text-center text-h4 items-center"
          style="margin:20px"
        >
          {{ dropText }}
        </div>
        <div class="text-center items-center">
          or
        </div>
        <div
          class="text-center items-center"
        >
          <input
            id="selectedFile"
            type="file"
            :accept="supportedSingleFileFormats"
            multiple
            style="display: none;"
            @change="handleFiles('selectedFile')"
          >
          <input
            id="selectedFolder"
            type="file"
            directory
            webkitdirectory
            style="display: none;"
            @change="handleFiles('selectedFolder')"
          >
          <q-btn
            outline
            style="margin:10px"
            color="primary"
            label="Select File"
            @click="openFileSelection"
          />
          <div class="text-center items-center">
            or
          </div>
          <q-btn
            outline
            style="margin:10px"
            color="primary"
            label="Select Folder"
            @click="openFolderSelection"
          />
        </div>
        <div
          class="text-center text-uppercase text-body2  items-center"
          style="margin:30px;"
        >
          Supported Formats<br><b>{{ getSupportedFormats() }}</b>
        </div>
        <div
          class="text-center text-uppercase text-body2  items-center"
          style="margin:30px;"
        >
          Anonymization support for<br><b>{{ getSupportedAnonymizationFormats() }}</b><br>
          Provided by <a
            href="https://gitlab.com/empaia/integration/wsi-anon#wsi-anon"
            target="_blank"
          >WSI Anon</a>
        </div>
      </div>
    </div>
    <!-- UPLOAD NOT SUPPORTED (shown if tus not supported) -->
    <div
      v-else
      class="row dropzone"
    >
      <div
        class="row justify-center items-center"
        style="font-size: 20px; color: gray; width: 100%"
      >
        <q-icon
          name="warning"
          style="font-size: 4rem;"
        />
        <div style="width: 100%; text-align: center">
          Upload not supported <br>by the current version<br> of your browser. <br><br>Please update.
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { v5 as uuidv5 } from 'uuid'
import * as tus from 'tus-js-client'
import FilteredFileDrop from '@empaia/filtered-file-drop'

export default {
  name: 'Dropzone',
  props: {
    dropText: {
      type: String,
      default: 'Drop files here'
    },
    supportedFormats: {
      type: Array,
      default: function () {
        return []
      }
    },
    supportedMultiFileFormats: {
      type: Object,
      default: function () {
        return {}
      }
    },
    supportedAnonymizationFormats: {
      type: Array,
      default: function () {
        return []
      }
    },
    alreadyAddedFileIds: {
      type: Array,
      default: function () {
        return []
      }
    },
    fileGroup: {
      type: String,
      default: 'unknown'
    }
  },
  data: function () {
    return {
      uploadSupported: true,
      alreadAddedCount: 0
    }
  },
  computed: {
    supportedSingleFileFormats: function () {
      const formats = []
      for (const supportedFormat of this.supportedFormats) {
        if (!(supportedFormat in this.supportedMultiFileFormats)) {
          formats.push('.' + supportedFormat)
        }
      }
      return formats.toString()
    }
  },
  created: function () {
    if (!tus.isSupported) {
      this.uploadSupported = false
    } else {
      this.createFileUid = (file) => {
        const lastModifiedInSeconds = Math.floor(file.lastModified / 1000) * 1000
        return uuidv5(file.name + file.size + lastModifiedInSeconds, this.fileGroup)
      }
      this.alreadAddedCount = 0
      this.checkFileAlreadyAdded = (file) => {
        if (this.alreadyAddedFileIds.includes(file.uid)) {
          this.alreadAddedCount++
          return true
        } else {
          return false
        }
      }
      this.getFileExtension = (file) => {
        if (file.name.includes('.ome.')) {
          return file.name.substring(file.name.lastIndexOf('.ome.') + 1)
        } else {
          return file.name.substring(file.name.lastIndexOf('.') + 1)
        }
      }
      this.filteredFileDrop = new FilteredFileDrop(
        this.supportedFormats,
        this.supportedMultiFileFormats,
        this.createFileUid,
        this.checkFileAlreadyAdded,
        this.getFileExtension
      )
    }
  },
  methods: {
    openFileSelection () {
      document.getElementById('selectedFile').click()
    },
    openFolderSelection () {
      document.getElementById('selectedFolder').click()
    },
    handleFiles (inputElementId) {
      var inputElementFiles = document.getElementById(inputElementId).files
      const addedFilesCount = inputElementFiles.length
      var files = []
      if (addedFilesCount > 0) {
        this.alreadAddedCount = 0
        files = this.filteredFileDrop.handleInputElementFiles(inputElementFiles)
        if (files.length === 0) {
          const unsupportedFilesCount = addedFilesCount - this.alreadAddedCount
          this.notifyNoFileFoundOrAlreadyUploaded(this.alreadAddedCount, unsupportedFilesCount)
        }
        document.getElementById(inputElementId).value = null
      }
      this.$emit('dropped-files', files)
    },
    async handleDropEvent (event) {
      const droppedFilesCount = event.dataTransfer.files.length
      this.alreadAddedCount = 0
      const files = await this.filteredFileDrop.handleDropEvent(event)
      if (files.length === 0) {
        const unsupportedFilesCount = droppedFilesCount - this.alreadAddedCount
        this.notifyNoFileFoundOrAlreadyUploaded(this.alreadAddedCount, unsupportedFilesCount)
      }
      this.$emit('dropped-files', files)
    },
    handleOnDragOver (event) {
      const element = document.querySelector('.dropzoneBorder')
      element.style.borderStyle = 'solid'
      element.style.borderColor = '#6699ff'
    },
    handleOnDragLeave (event) {
      const element = document.querySelector('.dropzoneBorder')
      element.style.borderStyle = 'dashed'
      element.style.borderColor = 'grey'
    },
    getSupportedFormats () {
      let supportedFormatsString = ''
      for (const supportedFormat of this.supportedFormats) {
        supportedFormatsString += supportedFormat
        if (Object.keys(this.supportedMultiFileFormats).includes(supportedFormat)) {
          supportedFormatsString += ' ('
          for (const additionalFileExtension of this.supportedMultiFileFormats[supportedFormat].fileExtensions) {
            supportedFormatsString += additionalFileExtension + ', '
          }
          supportedFormatsString = supportedFormatsString.substring(0, supportedFormatsString.length - 2)
          supportedFormatsString += ')'
        }
        supportedFormatsString += ' - '
      }
      supportedFormatsString = supportedFormatsString.substring(0, supportedFormatsString.length - 3)
      return supportedFormatsString
    },
    getSupportedAnonymizationFormats () {
      let supportedAnonymizationFormatsString = ''
      for (const supportedFormat of this.supportedAnonymizationFormats) {
        supportedAnonymizationFormatsString += supportedFormat
        supportedAnonymizationFormatsString += ' - '
      }
      supportedAnonymizationFormatsString = supportedAnonymizationFormatsString.substring(0, supportedAnonymizationFormatsString.length - 3)
      return supportedAnonymizationFormatsString
    },
    notifyNoFileFoundOrAlreadyUploaded (alreadyAddedFilesCount, unsupportedFilesCount) {
      let message = ''
      if (alreadyAddedFilesCount > 0) {
        message = `Found ${alreadyAddedFilesCount} already added file(s).`
      }
      if (unsupportedFilesCount > 0) {
        message = `Found ${unsupportedFilesCount} unsupported file(s). Check supported file extensions.`
      }
      if (alreadyAddedFilesCount > 0 && unsupportedFilesCount > 0) {
        message = `Found ${alreadyAddedFilesCount} already added file(s) and ${unsupportedFilesCount} unsupported file(s). Check supported file extensions.`
      }
      this.$q.notify({
        timeout: 10000,
        message: message,
        actions: [
          { label: 'Ok', color: 'white', handler: () => {} }
        ]
      })
    }
  }
}
</script>

<style scoped lang="scss">
.dropzone {
  width: 100%;
  height: 100%;
}
.dropzoneBorder {
  border-style: dashed;
  border-width: thin;
  border-color: grey;
}
</style>
